<form [formGroup]="cityForm">
  <mat-form-field class="example-full-width">
    <input matInput placeholder="City Name" formControlName="city">

    <mat-error *ngIf="!cityForm.get('city').valid && cityForm.get('city').touched">Please enter City name
    </mat-error>

  </mat-form-field>

  <div formGroupName="location">
    <mat-form-field class="example-full-width">
      <input matInput placeholder="Latitude" formControlName="lat"
        [ngClass]="{invalid: cityForm.get('location.lat').invalid && cityForm.get('location.lat').touched}">
      <mat-error *ngIf="cityForm.get('location.lat').invalid && cityForm.get('location.lat').touched">
        <mat-error *ngIf="cityForm.get('location.lat').errors['required']">
          Please enter latitude
        </mat-error>
        <mat-error *ngIf="cityForm.get('location.lat').errors['pattern']">
          Please valid latitude
        </mat-error>
      </mat-error>
    </mat-form-field>

    <mat-form-field class="example-full-width">
      <input matInput placeholder="Longitude" formControlName="lon"
        [ngClass]="{invalid: cityForm.get('location.lon').invalid && cityForm.get('location.lon').touched}">
      <mat-error *ngIf="cityForm.get('location.lon').invalid && cityForm.get('location.lon').touched">
        <mat-error *ngIf="cityForm.get('location.lon').errors['required']">
          Please enter latitude
        </mat-error>
        <mat-error *ngIf="cityForm.get('location.lon').errors['pattern']">
          Please valid latitude
        </mat-error>
      </mat-error>
    </mat-form-field>
  </div>

  <div>
    <agm-map class="map" [zoom]="4" [latitude]="50.8898203" [longitude]="12.9118" (mapClick)="onChooseLocation($event)">
      <agm-marker [latitude]="lat" [longitude]="lon">
      </agm-marker>
    </agm-map>
  </div>


  <div class="button-row">
    <button [disabled]="!cityForm.valid" mat-flat-button color="primary" (click)="onSubmit(cityForm.value)">
      Save
    </button>

    <button mat-button (click)="onNoClick()">Cancel</button>
  </div>
</form>